/**
 * _NX
 * @author Shogo
 */

public class ShFloat extends ShReal
{
	public static final long FRADIX = 1000000000000000000L;	//1̈ʂ̈ʒu
	public static final long DRADIX = 100000000000000000L;	//0.1̈ʂ̈ʒu
	public static final long HRADIX = 1000000000L;	//̔
	public static final int  NUMFIG = 18;	//錅
	
	public static final ShFloat ZERO = new ShFloat(0, 0);
	public static final ShFloat ONE = getFloat(1);
	public static final ShFloat HALF = getFloat("0.5");

	///
	protected long value;
	///w
	protected int exp;
	
	protected ShFloat(long value, int exp)
	{
		this.value = value;
		this.exp = exp;
	}
	
	public static ShFloat getFloat(long num)
	{
		long value;
		int exp;
		int sign = 1;
		int rest;
		
		if(num==0) return ZERO;
		
		//
		sign = 1;
		if(num<0) {
			sign = -1;
			num = -num;
		}
		
		//
		value = num;
		
		//K
		exp = NUMFIG;
		while(value<DRADIX) {
			value*=10;
			exp--;
		}
		rest = 0;
		while(value>FRADIX) {
			rest = (int)(value % 10);
			value/=10;
			exp++;
		}
		if(rest>=5) value++;
		
		return new ShFloat(value*sign, exp);
	}
	
	public static ShFloat getFloat(long num, int exp)
	{
		ShFloat res = getFloat(num);
		res.exp += exp;
		return res;
	}
	
	public static ShFloat getFloat(String str)
	{
		int sign;
		long value;
		int exp;
		int index = 0;
		int len = str.length();
		int dexp = 1;
		char ch;
		
		value = exp = 0;
		
		//擾
		sign = 1;
		if((ch=str.charAt(index))=='-') {
			sign = -1;
			index++;
		} else if(ch=='+') {
			index++;
		}
		
		//wǂݍ
		for(;index<len && value<DRADIX;index++) {
			ch = str.charAt(index);
			if(ch==' ') continue;
			if(ch=='.') {
				if(value==0) {
					//1菬
					dexp = -1;
				} else {
					//1傫
					dexp = 0;
				}
				continue;
			}
			if(!Character.isDigit(str.charAt(index))) break;
			value = value*10 + Character.digit(ch, 10);
			exp += dexp;
			if(dexp<0 && value!=0) dexp = 0;
		}
		
		//0ꍇ̏
		if(value==0) {
			return new ShFloat(0,0);
		}
		
		//Ȃ[
		while(value<DRADIX) value*=10;
		
		
		//[
		if(index<len && Character.isDigit(ch = str.charAt(index))) {
			if(Character.digit(ch, 10)>=5) {
				value++;
				if(value>=FRADIX) {
					exp++;
					value/=10;
				}
			}
			index++;
		}
		
		if(index<len)
		{
			//w擾
			ch = str.charAt(index++);
			if(ch=='e' || ch=='E')
			{
				//w擾
				int exp_sign = 1;
				if((ch=str.charAt(index))=='-') {
					exp_sign = -1;
					index++;
				} else if(ch=='+') {
					index++;
				}
				
				int add_exp = 0;
				while(index<len && Character.isDigit(ch = str.charAt(index))) {
					add_exp = add_exp*10 + Character.digit(ch, 10);
					index++;
				}
				exp+=add_exp*exp_sign;
			}
		}
		return new ShFloat(value*sign, exp);
	}
	
	public static ShFloat getFloat(ShReal val)
	{
		ShFloat f = val.toShFloat();
		return new ShFloat(f.value, f.exp);
	}
	
	public long getValue()
	{
		return value;
	}
	
	public int getExp()
	{
		return exp;
	}
	
	public String toString() {
		return toString(NUMFIG);
	}
	
	public String toString(int nmax) {
		int nval = exp;
		
		//w肳ꂽŕ\łȂ
		//傫Ȓl⏬Ȓl͎w`ŕ\
		if(exp>nmax || nmax<(-exp+1)) return toStringExp(nmax);
		
		//Ƃ肠Œ菬_`ɕϊĂ݂
		if(nval<0) nval = 0;
		StringBuffer str = new StringBuffer(toStringFix(nmax - nval, nmax));
		
		//Ō0菜
		while(str.charAt(str.length()-1)=='0') {
			str.setLength(str.length()-1);
		}
		
		return str.toString();
	}
	
	/**
	 * Œ菬_`ŕ\
	 * @param nval ̌
	 * @param nmax Ԃ̍ő咷
	 * @return Œ菬_`̕Ԃ
	 */
	public String toStringFix(int nval, int nmax) {
		StringBuffer str = new StringBuffer(nmax);
		long last_fig = DRADIX;
		long val = value;
		int ex = exp;
		int i;
		
		//w肳ꂽŕ\Ȃ
		//傫Ȑ͎w\
		if(exp>nmax) return toStringExp(nval);
		
		//o
		if(val<0) {
			str.append("-");
			val = -val;
		}
		
		//[
		if(exp>0 && nval>nmax-exp) nval = nmax-exp;
		if(exp<0) nval += exp;
		for(i=0;i<exp;i++)  last_fig /= 10;
		for(i=0;i<nval;i++) last_fig /= 10;
		val += last_fig*5;	//ľܓ
		if(val>=FRADIX)
		{
			val /= 10;
			ex++;
		}
		
		//\
		for(i=0;i<ex;i++) {
			str.append(val/DRADIX);
			val = val%DRADIX * 10;
		}
		
		//\
		if(ex<=0) str.append("0.");
		else str.append(".");
		for(i=0;i>exp;i--) {
			str.append("0");
		}
		for(i=0;i<nval;i++) {
			str.append(val/DRADIX);
			val = val%DRADIX * 10;
		}
		return str.toString();
	}
	
	//w`ŕ\
	public String toStringExp(int nval) {
		StringBuffer str = new StringBuffer(nval+5);
		long val = value;
		int out_exp = exp - 1;		//ۂɕ\w
		long last_fig = DRADIX;	//\Ȃŏ̌
		int i;
		
		//o
		if(val<0) {
			str.append("-");
			val = -val;
		}
		
		//[
		for(i=0;i<=nval;i++) last_fig /= 10;
		val += last_fig * 5;
		
		if(val>=FRADIX) {
			val /= 10;
			out_exp++;
		}
		
		//o
		str.append(val/DRADIX);
		val = val%DRADIX * 10;
		str.append(".");
		for(i=0;i<nval-1;i++) {
			str.append(val/(FRADIX/10));
			val = val%DRADIX * 10;
		}
		
		//wo
		str.append("E");
		if(value!=0) str.append(out_exp);
		else str.append("0");
		return str.toString();
	}
	
	/**
	 * lɕϊB
	 *
	 * _ȉ͐؂̂Ă܂BIuWFNg̕\l̐Βl߂l̐ΒlȂ܂B
	 * @return ̃IuWFNg𐮐lɕϊl
	 */
	public long toLong() {
		long res;
		long last_fig = expToLong();
		
		//long`ł͕\Ȃ
		if(last_fig==0) {
			throw new ArithmeticException("I[o[t[");
		}
		res = value / last_fig;
		return res;
	}
	
	/**
	 * Ƃ߂lɕϊB
	 */
	public long round()
	{
		long res, mod;
		long last_fig = expToLong();
		
		//long`ł͕\Ȃ
		if(last_fig==0) {
			throw new ArithmeticException("I[o[t[");
		}
		
		//ϊs
		res = value / last_fig;
		mod = value % last_fig;
		
		//[
		mod *= 2;
		if(mod >= last_fig)
		{
			res++;
		}
		else if(mod < -last_fig)
		{
			res--;
		}
		
		return res;
	}
	
	public ShReal floor()
	{
		long res, mod;
		long last_fig = expToLong();
		
		//ϊ̕KvȂ
		if(last_fig==0) {
			return this;
		}
		
		//ϊs
		res = value / last_fig;
		mod = value % last_fig;
		
		if(mod < 0)
		{
			res--;
		}
		
		return ShFraction.getFraction(res);
	}
	
	public ShReal ceil()
	{
		long res, mod;
		long last_fig = expToLong();
		
		//ϊ̕KvȂ
		if(last_fig==0) {
			return this;
		}
		
		//ϊs
		res = value / last_fig;
		mod = value % last_fig;
		
		if(mod > 0)
		{
			res++;
		}
		
		return ShFraction.getFraction(res);
	}

	public ShReal rint()
	{
		long res, mod;
		long last_fig = expToLong();
		
		//ϊ̕KvȂ
		if(last_fig==0) {
			return this;
		}
		
		//ϊs
		res = value / last_fig;
		mod = value % last_fig;
		
		//[
		mod *= 2;
		if(mod > last_fig)
		{
			res++;
		}
		else if(mod == last_fig)
		{
			res = (res+1) & (~1);
		}
		else if(mod < -last_fig)
		{
			res--;
		}
		else if(mod == -last_fig)
		{
			res = -((-res+1) & (~1));
		}
		
		return ShFraction.getFraction(res);
	}
	
	private long expToLong()
	{
		int i;
		long last_fig = FRADIX;
		if(exp<0) return FRADIX;
		for(i=0;i<exp && last_fig!=0;i++) last_fig /= 10;
		return last_fig;
	}
	
	/**
	 * thisnumber𑫂ʂԂB
	 * @param number 
	 * @return thisnumber𑫂
	 */
	public ShNumber add(ShNumber number)
	{
		if(number instanceof ShReal)
		{
			return add((ShReal)number);
		}
		return number.add(this);
	}
	
	/**
	 * thisnumber𑫂ʂԂB
	 * @param number 
	 * @return thisnumber𑫂
	 */
	public ShReal add(ShReal number)
	{
		return addsub(number.toShFloat(), 1);
	}
	
	/**
	 * thisnumberʂԂB
	 * @param number 
	 * @return thisnumber
	 */
	public ShNumber sub(ShNumber number)
	{
		if(number instanceof ShReal)
		{
			return sub((ShReal)number);
		}
		ShComplex c = toShComplex();
		return c.sub(number);
	}
	
	/**
	 * thisnumberʂԂB
	 * @param number 
	 * @return thisnumber
	 */
	public ShReal sub(ShReal number)
	{
		return addsub(number.toShFloat(), -1);
	}
	
	public ShFloat addsub(ShFloat a, int sign)
	{
		int  out_exp;	//o͂w
		int  add_exp;	//w
		long out_val;	//o͂鉼
		long add_val;	//
		
		if(value==0) return a;
		if(a.value==0) return this;
		
		//o͂̎w͑傫قɍ킹
		if(exp<a.exp) {
			out_exp = a.exp;
			out_val = a.value * sign;
			add_val = value;
			add_exp = exp;
		} else {
			out_exp = exp;
			out_val = value;
			add_val = a.value * sign;
			add_exp = a.exp;
		}
		
		//w킹
		long fraction = 0;	//[
		while(add_exp<out_exp) {
			fraction = add_val%10;
			add_val /= 10;
			add_exp++;
		}
		
		//Zs
		out_val += add_val;
		
		//[
		if(fraction>=5) out_val++;
		if(fraction<=-5) out_val--;
		
		//K
		if(out_val==0) return ZERO;
		while(out_val<DRADIX && out_val>-DRADIX) {
			out_val*=10;
			out_exp--;
		}
		
		//ʂԂ
		return new ShFloat(out_val, out_exp);
	}

	/**
	 * thisnumber|ʂԂB
	 * @param number |鐔
	 * @return thisnumber|
	 */
	public ShNumber mul(ShNumber number)
	{
		if(number instanceof ShReal)
		{
			return mul((ShReal)number);
		}
		return number.mul(this);
	}
	
	/**
	 * thisnumber|ʂԂB
	 * @param number |鐔
	 * @return thisnumber|
	 */
	public ShReal mul(ShReal number)
	{
		ShFloat v = number.toShFloat();
		long a = value, b = v.value;
		
		//ʂƉʂɕ
		long ah = a/HRADIX, al = a%HRADIX;
		long bh = b/HRADIX, bl = b%HRADIX;
		
		//vZ
		long out_vall = ah*bl+al*bh + (al*bl)/HRADIX;
		long out_valh = ah*bh + out_vall / HRADIX;
		int  out_exp = exp + v.exp;
		out_vall %= HRADIX;
		
		//K
		if(out_valh<DRADIX && out_valh>-DRADIX) {
			out_exp--;
			out_vall *= 10;
			out_valh = out_valh*10 + out_vall/HRADIX;
			out_vall %= HRADIX;

		}
		
		//ۂߏ
		if(out_vall>=(HRADIX/2)) out_valh++;
		if(out_vall<=-(HRADIX/2)) out_valh--;
		return new ShFloat(out_valh, out_exp);
	}
	
	/**
	 * thisnumberŊʂԂB
	 * @param number 鐔
	 * @return thisnumberŊl
	 */
	
	public ShNumber div(ShNumber number)
	{
		if(number instanceof ShReal)
		{
			return div((ShReal)number);
		}
		ShComplex c = toShComplex();
		return c.div(number);
	}
	
	/**
	 * thisnumberŊʂԂB
	 * @param number 鐔
	 * @return thisnumberŊl
	 */
	
	public ShReal div(ShReal number)
	{
		ShFloat a = number.toShFloat();
		long x = value, y = a.value;
		int sign = 1;
		
		if(x==0) return this;
		if(y==0) {
			throw new ArithmeticException("0ŏZ܂.");
		}
		
		//Zɕl͖̂ʓ|Ȃ̂ł͂Ă
		if(x<0)
		{
			x = -x;
			sign = -1;
		}
		if(y<0)
		{
			y = -y;
			sign = -sign;
		}
		
		//Zs
		long out_value = x/y;
		int  out_exp = exp-a.exp;
		if(out_value!=0) out_exp++;
		x %= y;

		while(out_value<DRADIX) {
			long fig;	//݌vŽ̒l
			x *= 5;
			fig = x/y;
			x = (x%y) * 2;
			fig = fig*2 + x/y;
			x %= y;
			out_value = out_value*10 +fig;
		}
		
		//ۂߏ
		if((x*2)>=y) out_value++;
		
		return new ShFloat(sign * out_value, out_exp);
	}
	
	public ShReal div(long number)
	{
		int sign = 1;
		long out_val = value;
		int out_exp = exp;
		long mod;
		
		if(value==0) return this;
		
		//͂Ă
		if(number<0)
		{
			number = -number;
			sign = -1;
		}
		if(out_val<0)
		{
			out_val = -out_val;
			sign = -sign;
		}
		
		//Zs
		mod = out_val % number;
		out_val /= number;
		
		//K
		while(out_val<DRADIX)
		{
			out_val *= 10;
			mod *= 10;
			out_val += mod / number;
			mod %= number;
			out_exp--;
		}
		
		//ۂߏ
		if(mod*2>=number) out_val++;
		
		return new ShFloat(sign*out_val, out_exp);
	}
	
	/**
	 * ShFloat`ɕϊlԂB
	 * @return ̃IuWFNgShFloat`ɕϊl
	 */
	public ShFloat toShFloat()
	{
		return this;
	}

	/**
	 * thisnumber̔rsB
	 * @return this<number̂Ƃ, this==number̂Ƃ0, this>number̂Ƃ
	 */
	public int cmp(ShReal number)
	{
		ShFloat a = number.toShFloat();
		int sign = 1;
		long res;
		
		//̔r
		if(value<0 && a.value>=0) return -1;
		if(value>0 && a.value<=0) return 1;
		if(value<0) sign = -1;
		
		//w̔r
		res = (exp - a.exp) * sign;
		
		//̔r
		if(res==0) res = (value - a.value) * sign;
		
		//ʂԂ
		if(res>0) return 1;
		else if(res<0) return -1;
		return 0;
	}
	
	/**
	 * ԂB
	 * @return Ȃ畉, Ȃ琳, 0Ȃ0ԂB
	 */
	public int sign()
	{
		if(value>0) return 1;
		else if(value<0) return -1;
		return 0;
	}
	
	public ShReal abs()
	{
		if(value<0)
		{
			return new ShFloat(-value, exp);
		}
		return this;
	}
	
	public boolean equals(Object obj)
	{
		ShFloat f;
		if(obj instanceof ShFloat)
		{
			f = (ShFloat)obj;
			if(value==f.value && exp==f.exp)
			{
				return true;
			}
		}
		return false;
	}
}