/**
 * ̊{NX
 * @author Shogo
 */


public abstract class ShReal implements ShNumber
{
	public final static ShFraction ZERO = new ShFraction(0, 1);
	public final static ShFraction ONE = new ShFraction(1, 1);
	public final static ShFloat PI     = ShFloat.getFloat("3.1415926535897932384");
	public final static ShFloat E      = ShFloat.getFloat("2.7182818284590452353");
	public final static ShFloat LOG10  = ShFloat.getFloat("2.3025850929940456840");

	/**
	 * num\ShRealNXԂB
	 *
	 * ŕ\ƂShFractionAłȂꍇShRealԂ܂B
	 * @param num \l
	 * @return num\ShReal
	 */
	public static ShReal getReal(long num)
	{
		return ShFraction.getFraction(num);
	}
	
	public static ShReal getReal(long num, int exp)
	{
		return ShFraction.getFraction(num, 1, exp);
	}
	
	public static ShReal getReal(String str)
	{
		ShFloat f = ShFloat.getFloat(str);
		return ShFraction.getFraction(f.getValue(), ShFloat.FRADIX, f.getExp());
	}
	
	/**
	 * thisnumber𑫂ʂԂB
	 * @param number 
	 * @return thisnumber𑫂
	 */
	public abstract ShReal add(ShReal number);
	
	/**
	 * thisnumberʂԂB
	 * @param number 
	 * @return thisnumber
	 */
	public abstract ShReal sub(ShReal number);
	
	/**
	 * thisnumber|ʂԂB
	 * @param number |鐔
	 * @return thisnumber|
	 */
	public abstract ShReal mul(ShReal number);
	
	/**
	 * thisnumberŊʂԂB
	 * @param number 鐔
	 * @return thisnumberŊl
	 */
	public abstract ShReal div(ShReal number);
	
	/**
	 * thisnumberŊʂԂB
	 * @param number 鐔
	 * @return thisnumberŊl
	 */
	public abstract ShReal div(long number);
	
	/**
	 * ShFloat`ɕϊlԂB
	 * @return ̃IuWFNgShFloat`ɕϊl
	 */
	public abstract ShFloat toShFloat();
	
	/**
	 * thisnumber̔rsB
	 * @return this<number̂Ƃ, this==number̂Ƃ0, this>number̂Ƃ
	 */
	public int cmp(ShReal number)
	{
		ShReal r = sub(number);
		return r.sign();
	}
	
	/**
	 * ԂB
	 * @return Ȃ畉, Ȃ琳, 0Ȃ0ԂB
	 */
	public abstract int sign();
	
	/**
	 * f`ɕϊlԂ
	 * @return fɕϊl
	 */
	public ShComplex toShComplex()
	{
		return new ShComplex(this);
	}
	
	public abstract long toLong();
	public abstract long round();
	public abstract ShReal floor();
	public abstract ShReal ceil();
	public abstract ShReal rint();
	public abstract ShReal abs();
	
	/*********************** ȉlZ ***********************/
	/**
	 * ̐Βl߂܂
	 * @param val Βl߂l
	 * @return Βl
	 */
	public static ShFloat abs(ShFloat val)
	{
		return (ShFloat)(val.abs());
	}
	
	/**
	 * ̐Βl߂܂
	 * @param val Βl߂l
	 * @return Βl
	 */
	public static ShFraction abs(ShFraction val)
	{
		return (ShFraction)(val.abs());
	}
	
	/**
	 * ̐Βl߂܂
	 * @param val Βl߂l
	 * @return Βl
	 */
	public static ShReal abs(ShNumber val)
	{
		return val.abs();
	}

	/**
	 * ̕vZ܂B
	 *
	 * wIȕ̋ߎlԂ܂B
	 * @param val ߂l
	 * @return val̐̕
	 */
	public static ShReal sqrt(ShReal val)
	{
		ShReal v = val.abs();
		ShReal res = ShFloat.getFloat(v);
		ShReal last;
		
		int i;
		
		for(i=0;i<200;i++) {
			last = res;
			res = (v.div(res).add(res)).div(2);
			if(last.equals(res)) break;
		}
		
		return res;
	}
	
	/**
	 * ߂܂B
	 * @param val ߂WAPʂ̊px
	 * @return ̒l
	 */
	public static ShReal sin(ShReal val)
	{
		//-pipiɐK
		ShReal x = ShFloat.getFloat(val);	//
		x = IEEEremainder(x, PI.add(PI));
		
		ShReal num2 = x.mul(x);	//͒l2
		ShReal err = x.abs().mul(ShFloat.getFloat("1E-20"));
		ShReal list[] = new ShReal[50];
		int num_list;
		int i = 1;
		for(num_list=0;num_list<50;) {
			list[num_list++] = x;
			if(x.abs().cmp(err)<=0) break;
			x = x.mul( num2.div(-(i+1)*(i+2)) );
			i+=2;
		}
		
		ShReal res = ShReal.ZERO;
		for(i=num_list-1;i>=0;i--)
		{
			res = list[i].add(res);
		}
		return res;
	}
	
	/**
	 * ]߂܂B
	 * @param val ]߂WAPʂ̊px
	 * @return ]̒l
	 */
	public static ShReal cos(ShReal val)
	{
		return sin(val.add(PI.div(2)));
	}
	
	/**
	 * ڂ߂܂B
	 * @param val ڂ߂WAPʂ̊px
	 * @return ڂ̒l
	 */
	public static ShReal tan(ShReal val)
	{
		return sin(val).div(cos(val));
	}

	/**
	 * ̋t֐߂܂B
	 * @param val ̒l̋tԂ
	 * @return t̒l
	 */
	public static ShReal asin(ShReal val) {
		ShReal num2;
		ShReal x;
		
		//-1`1Ɏ܂Ă邩R
		int cmp_res = val.abs().cmp(ShFloat.ONE);
		if(cmp_res>0)
		{
			throw new ArithmeticException("`͂ݏo܂");
		}
		else if(cmp_res==0)
		{
			if(val.sign()>0)
				return PI.div(2);
			return PI.div(-2);
		}
		
		//Βl傫ƌvZɎԂ̂
		//Βl0.5𒴂ĂƂ0.5ȓŌvZł悤ɂ
		if(val.abs().cmp(ShFloat.HALF)>=0) {
			x = sqrt(ShFloat.ONE.sub(val.mul(val)));
		} else {
			x = val.toShFloat();
		}
		
		//vZJn
		num2 = x.mul(x);
		ShReal err = x.abs().mul(ShFloat.getFloat("1E-20"));
		ShReal list[] = new ShReal[120];
		int num_list;
		int i = 1;
		for(num_list=0;num_list<120;)
		{
			ShReal a = x.div(i);
			list[num_list++] = a;
			if(a.abs().cmp(err)<=0) break;
			x = x.mul(num2.mul(ShFloat.getFloat(i))).div(i+1);
			i+=2;
		}
		
		ShReal res = ShReal.ZERO;
		for(i=num_list-1;i>=0;i--)
		{
			res = list[i].add(res);
		}
		
		if(val.abs().cmp(ShFloat.HALF)>=0) {
			res = PI.div(2).sub(res);
			if(val.sign()<0) res = res.div(-1);
		}
		return res;
	}
	
	/**
	 * ]̋t֐߂܂B
	 * @param val ̒l̋t]Ԃ
	 * @return t]̒l
	 */
	public static ShReal acos(ShReal val) {
		return PI.div(2).sub(asin(val));
	}
	
	/**
	 * ڂ̋t֐߂܂B
	 * @param val ̒l̋tڂԂ
	 * @return tڂ̒l
	 */
	public static ShReal atan(ShReal val) {
		ShReal x = val.abs().toShFloat();
		boolean flag1 = false;	//̐̐Βl1ȏォ
		boolean flag2 = false;	//0.5ȏォ
		
		flag1 = (x.cmp(ShFloat.ONE)>0);
		if(flag1)
		{
			x = ShFloat.ONE.div(x);
		}
		
		flag2 = (x.cmp(ShFloat.HALF)>0);
		if(flag2)
		{
			x = (ShFloat.ONE.sub(x)).div(ShFloat.ONE.add(x));
		}
		
		
		ShReal err = x.abs().mul(ShFloat.getFloat("1E-20"));
		ShReal num2 = x.mul(x).div(-1);
		ShReal list[] = new ShReal[50];
		
		int num_list;
		int i = 1;
		for(num_list=0;num_list<50;)
		{
			ShReal a = x.div(i);
			list[num_list++] = a;
			if(a.abs().cmp(err)<=0) break;
			x = x.mul(num2);
			i+=2;
		}
		
		ShReal res = ShReal.ZERO;
		for(i=num_list-1;i>=0;i--)
		{
			res = list[i].add(res);
		}
		
		if(flag2)
		{
			res = PI.div(4).sub(res);
		}
		
		if(flag1)
		{
			res = PI.div(2).sub(res);
		}
		
		if(val.sign()<0)
		{
			res = res.div(-1);
		}
		return res;
	}
	
	/**
	 * IC[eShReallŗݏ悵lԂB
	 * @param val w肵w
	 * @return e^val̒l
	 */
	public static ShReal exp(ShReal val)
	{
		//vZ
		long ival = val.toLong();
		int sign = -1;
		ShReal e = E;
		ShReal ires = ShFloat.ONE;
		if(ival<0) {
			ival = -ival;
			sign = -1;
		}
		long tmp = ival;
		while(tmp!=0)
		{
			if((tmp&1)!=0)
			{
				ires = ires.mul(e);
			}
			e = e.mul(e);
			tmp >>= 1;
		}
		if(sign<0) {
			ival = -ival;
			ires = ONE.div(ires);
		}
		
		//vZ
		ShReal fval = val.sub(ShFloat.getFloat(ival));
		ShReal x = fval;
		ShReal err = x.abs().mul(ShFloat.getFloat("1E-20"));
		ShReal list[] = new ShReal[20];
		int num_list;
		int i = 2;
		for(num_list=0;num_list<20;)
		{
			list[num_list++] = x;
			x = x.mul(fval).div(i);
			i++;
			if(x.abs().cmp(err)<=0) break;
		}
		
		ShReal res = ShReal.ZERO;
		for(i=num_list-1;i>=0;i--)
		{
			res = list[i].add(res);
		}
		res = res.add(ShFloat.ONE);
		
		return res.mul(ires);
	}

	/**
	 * IC[eƂΐ߂B
	 * @param val 0łȂf
	 * @return val̑ΐ
	 */
	public static ShReal log(ShReal val)
	{
		if(val.sign()<0)
		{
			throw new ArithmeticException("`͂ݏo܂");
		}
		int e = val.toShFloat().getExp();
		val = val.div(ShFloat.getFloat(1, e));
		ShReal x = val.sub(ShFloat.ONE).div(val.add(ShFloat.ONE));
		ShReal err = x.abs().mul(ShFloat.getFloat("1E-20"));
		ShReal num2 = x.mul(x);
		ShReal res = ShReal.ZERO;
		
		int i;
		for(i=1;i<300 && x.abs().cmp(err)>=0 ;i+=2) {
			res = res.add(x.div(i));
			x = x.mul(num2);
		}
		res = res.mul(ShFloat.getFloat(2));
		res = res.add(LOG10.mul(ShFloat.getFloat(e)));
		return res;
	}

	/**
	 * pΐ߂
	 * @param val 0傫l
	 * @return val̏pΐ
	 */
	public static ShReal log10(ShReal val)
	{
		return log(val).div(LOG10);
	}

	public static long round(ShReal val)
	{
		return val.round();
	}
	
	public static ShReal floor(ShReal val)
	{
		return val.floor();
	}
	
	public static ShReal ceil(ShReal val)
	{
		return val.ceil();
	}
	
	public static ShReal rint(ShReal val)
	{
		return val.rint();
	}

	public static long pow(long a, long b)
	{
		long res = 1, tmp = a;
		if(b<0) return 0;
		while(b!=0)
		{
			if((b&1)!=0)
			{
				res *= tmp;
			}
			tmp *= tmp;
		}
		return  res;
	}

	public static ShReal atan2(ShReal y, ShReal x)
	{
		if(x.sign()==0)
		{
			if(y.sign()>0)
			{
				return PI.div(2);
			}
			else if(y.sign()<0)
			{
				return PI.div(2).add(PI);
			}
			return ShFloat.ZERO;
		}
		ShReal res = atan(y.div(x));
		
		if(x.sign()<0)
		{
			if(y.sign()>=0)
			{
				res = res.add(PI);
			}
			else
			{
				res = res.sub(PI);
			}
		}
		return res;
	}
	
	public static ShReal sinh(ShReal val)
	{
		ShReal e = exp(val);
		return e.sub(ShReal.ONE.div(e)).div(2);
	}
	
	public static ShReal cosh(ShReal val)
	{
		ShReal e = exp(val);
		return e.add(ShReal.ONE.div(e)).div(2);
	}
	
	public static ShReal tanh(ShReal val)
	{
		ShReal e = exp(val);
		ShReal ei = ShReal.ONE.div(e);
		return e.sub(ei).div(e.add(ei));
	}
	
	//oȐt֐
	public static ShReal asinh(ShReal num) {
		return log(num.add(sqrt(num.mul(num).add(ONE)) ));
	}
	
	public static ShReal acosh(ShReal num) {
		return log(num.add(sqrt(num.mul(num).sub(ONE)) ));
	}
	
	public static ShReal atanh(ShReal num) {
		return log((ONE.add(num)).div(ONE.sub(num))).div(2);
	}
	
	public static ShReal pow(ShReal a, ShReal b)
	{
		return exp(log(a).mul(b));
	}

	public static ShReal IEEEremainder(ShReal a, ShReal b)
	{
		ShReal n = (a.div(b)).rint();
		return a.sub(n.mul(b));
	}
	
	public static ShReal toRadians(ShReal angdeg)
	{
		return angdeg.mul(PI).div(180);
	}
	
	public static ShReal toDegrees(ShReal angrad)
	{
		return angrad.mul(ShFloat.getFloat(180)).div(PI);
	}
	
	public static ShReal max(ShReal a, ShReal b)
	{
		if(a.cmp(b)<0)
		{
			return b;
		}
		return a;
	}

	public static ShReal min(ShReal a, ShReal b)
	{
		if(a.cmp(b)>0)
		{
			return b;
		}
		return a;
	}

}